
v 4.06
======

- Добавлена команда конф. файла LEDS=ON/OFF (при использовании эмулятора
  на компьютере PC с нестандартным kbd контроллером 8042 напишите LEDS=OFF.
  Led-индикаторы клавиатуры будут отключены).


v 4.05C (20 May 1998)
=====================

- Улучшена (в очередной раз ;-) работа драйвера клавиатуры (в некоторых прог-
  раммах - например Soldat, оболочке MC, мониторе БК-11 приходил "паразитный"
  скан код от предыдущей нажатой клавиши). Fixed;

- При работе под Windows любой версии в некоторых случаях не восстанавливался
  экран БК после использования конфигурационного меню (F11). Ошибка исправлена;

- Проверена совместимость видеорежимов эмулятора еще с несколькими VGA (см.
  файл README.TXT).


v4.05 beta (24 Jan 1998)
========================

- Опция конф. файла "SwapRGB", переставлявшая местами второй и третий цвета
  палитры в режиме БК-11 убрана за ненадобностю;

- Автоматическое распознавание VGA с чипсетом Tseng и включение поддержки
  ET-4000+ если указана опция конф.файла "TsengVGA=auto";

- В некоторых случаях текущая палитра БК-11 восстанавливалась некорректно.
  Ошибка исправлена.


v4.05 alpha - fuck tseng! version (15 Jan 1998)
===============================================

- Внесены многочисленные изменения в драйвер клавиаутры эмулятора;

- Все образа ПЗУ БК теперь помещены в отдельную директорию (\ROM);

- Рулонный сдвиг наконец-то работает и на Tseng Labs VGA! При использовании
  Tseng ET4000/6000 и совместимых с Tseng адаптеров (напр. SiS 6202)
  добавьте строчку "TsengVGA=on" в конфигурационный файл эмулятора.
  Прошу обратить внимание что в режиме совместимости с Tseng вывод
  на экран осуществляется в 2 - 4 раза медленнее! Кроме того в данном
  режиме возможна некорректная работа с другими VGA. Напишите "TsengVGA=off"
  если Ваша VGA карта не имеет отношение к фирме Tseng! Выражаю признательность
  Эльтерману Павлу Бинаровичу за предоставленный на столь долгий период
  адаптер ET-6000 PCI !

- Цвета палитр в режиме БК-11М теперь полностью соответствуют реальным
  цветам на настоящей БК (у моего цветного монитора оказался неправильно
  распаянный кабель ;-)

- Для лучшей совместимости с другими эмуляторами длина файла DISKDRV.ROM
  теперь должна составлять 8192 байта (ранее было 8064, увеличение + 128
  байт). Т.к. данный образ ПЗУ загружается по адресу 160000 то все данные
  в файле начиная с 177600 игнорируются - во избежание пересечения с
  областью системных регистров;

- Устранена ошибка в драйвере клавиатуры приводившая к неработоспособности
  комбинации Control + F9;

- Добавлена возможность записи экрана БК в файл PCX (вместо неработающей
  функции dos shell). Пока модуль записи PCX не доделан, просьба об
  ошибках не сообщать!


v4.04 & 4.04 beta
=================

- (D)ump command added to built-in debugger;

- implementing emulation of i/o port 177700 bit 2 (wait for interrupt);

- read word module speedup;

- EMT 36 intercept works FAR more reliable than ever (Revolt loader and
  OS BK doesnt crash emulator even if intercept module is turned on!);

- several minor PDP11 opcode decoding speed ups.


v4.03 / 4.03 BETA
=================

- Выяснена причина "неработоспособности" Revolt by Star Software/Bell/PVM: 
  перед запуском загрузчика следует отключить перехват EMT 36! (F11, E). 
  После этого игра загружается и работает нормально.

- Исправлены ошибки в декодировании некоторых редко применяемых адресациях
  команды XOR (напр. XOR PC, MEM и XOR PC, REG);

- Найдена и исправлена ошибка, допущенная при оптимизации однооперандных
  команд в версии 4.01 (в командах типа ADC / ADCB (REG)+), приводившая
  к неработоспособности Block Out'а.


v4.01
=====

- EVERYTHING! Single operator opcodes - executed at TOP speed now!


v3.04
=====

- Internal test version.


v3.03 (30 April 1997)
=====================

- Слегка ускорены процедуры переключения палитр БК-11М и чтения/записи
  памяти БК;

- Более гибкий анализатор конфигурационного файла (BK11_EML.CFG);

- Добавлены следующие команды конф. файла: IOEntry (изменение адреса
  перехвата чтения/записи физического сектора в дисковом ПЗУ по адресу
  160000), TsengBIOS (рекомендуется включить для совместимости с Tseng VGA) и
  SwapRGB (переставить местами зеленый и синий цвета - по многочисленным
  просьбам :-)

- Исправлена ошибка в эмуляции команд типа INC PC / DEC PC, приводившая
  к неработоспособнисти программ TERRA1 и groline.dem (BK-Mania'96).


v3.02 (14 April 1997)
=====================

- Незначительные внутренние изменения в коде.


v3.01 (9 April 1997), F.A.S.T (Frequency Analyzed Set Translator) release
=========================================================================

- Проведена серьезная оптимизация эмулятора по скорости работы и размеру кода.
  Размер распакованного EXE-модуля сокращен более чем в 2 раза (с 450 KB до
  200 KB). Достигнуто ускорение выполнения прикладных программ в среднем на 
  5-10% благодаря применению системы F.A.S.T для декодирования (сверхбыстрое
  исполнение наиболее часто встречающихся команд PDP-11);

- Добавлено подтверждение выхода из эмулятора (клавиша F12);

- Добавлена опция в конфигурационное меню, позволяющая в процессе работы
  включать и выключать эмуляцию BK Speaker'а (F11, O);

- Исследована и устранена проблема с использованием джойстика в игровых 
  программах Cybernoid (CSI), Space (SW corp), Plate (RDA corp) и др. Для
  нормальной работы данных программ теперь достаточно временно отключить
  мышь через конфигурационное меню (F11, M);

- Исправлена ошибка с перезагрузкой русского шрифта после просмотра
  экрана БК во встроенном отладчике (Control F11, V);

- Выдача сообщения MS-DOS "Error, (A)bort, (R)etry, (I)gnore, (F)ail"
  при ошибке обращения к устройству IBM PC заблокирована (установлен
  собственный обработчик int 24h) для предотвращения подвисания эмулятора
  при ошибке чтения или записи на винчестер IBM PC;

- В режиме максимального ускорения (Control+F12) теперь можно играть в игры
  на keypad-joystick'е, переключать тип экрана Mono/Color (клавиша 
  Scroll Lock), приостанавливать и продолжать работу эмулятора
  (Control + Pause);

- Команда PDP-11 вида SOB PC, MET теперь декодируется и исполняется (в преды-
  дущих версиях эмулятор при встрече такой команды выводил сообщение об
  ошибке и выходил в MS-DOS);

- В режиме паузы (после нажатия Control + Pause) выдача звуков на Adlib
  блокируется. После нажатия любой клавиши и продолжения работы программы
  музыка также продолжает играть с прерванного места;

- Исправлена масса других незначительных ошибок;

- К файлам документации добавлен файл Q&A.TXT, в котором даны ответы
  на наиболее часто задаваемые автору вопросы о эмуляторе;

- Основная документация приведена в соответствие с новой версией эмулятора.


v2.06 (11 March 1997)
=====================

- Добавлена pause hot-key (Control + Pause/Break). Работа эмулятора приостанав-
  ливается. Для продолжения нажмите любую клавишу;

- Исправлена ошибка, приводившая к неработоспособности команд конфигурацион-
  ного файла изменявших цветовую гамму (RED=, GREEN=, BLUE=, MAGENTA= и др.);

- Исправлена подпрограмма переключения палитр БК-0011М. Теперь переключение
  палитры не вызвает появление на экране паразитных "полосок" (адаптеры S3);

- Внесены изменения в драйвер клавиатуры.


v2.05 Major Release (25 Feb 1997)
=================================

- Полностью переписана работа с экраном (special thanks to Ni0l-MiCR0 !!!)
  Монохромный режим работает теперь с такой же скоростью как и цветной.
  Файлы XCOLOR.CRT, XMONO.CRT, MODETEST.EXE больше не включаются в состав
  эмулятора за ненадобностью. Используется новый видеорежим являющийся
  модификацией стандартного режима EGA, который должен работать на всех 
  VGA-совместимых картах и VGA мониторах. Рулонный сдвиг эмулируется теперь
  быстро и аппаратно (без пересылок в видеобуфере). Команда MonoScroll удалена
  из списка команд конфигурационного файла за ненадобностью. Команда AltScr
  оставлена но имеет теперь другое назначение;

- Размер исполняемого модуля (BK11_EML.EXE) существенно сокращен;

- Исправлена ошибка с байтовой записью в порт 177662 в режиме БК-0011М;

- Исправлена работа конфигурационного меню эмулятора (F11). Добавлено
  несколько новых опций;

- Внесены незначительные изменения в драйвер клавиатуры;

- Повышена стабильность работы эмулятора на компьютерах с нестандартной
  микросхемой контроллера клавиатуры (Jetkey/Futjitsu/etc);

- Добавлена команда CFG-файла FastSob (см. основную документацию приложение#3);

- Исправлена ошибка во встроенном дизассемблере PDP-11, приводившая
  к неверному выводу команд с адресацией 77 (например CALL @100020);

- Улучшена стабильность перезапуска по нажатию клавиши PrintScreen/Sysrq
  (переход по адресу 100000): таймер 50HZ выключается, все биты в PSW
  сбрасываются;

- Исправлены и дополнены файлы документации (теперь в ней отражены все
  сделанные изменения). Изменился состав "комплекта поставки" эмулятора.


v1.06, v2.00, 2.01, 2.02, 2.03, 2.04
====================================

- Внутренние тестовые версии. Не распостранялись.


v1.05
=====

- Добавлена команда конфигурационнго файла - "MonoScroll=", позволяющая
  ускорить рулонный сдвиг в монохромном видеорежиме;

- Скомпилирована специальная версия эмулятора для ноутбука Compaq LTE-5000 :-)


v1.04
=====

- Исправлена ошибка в процедуре загрузки BMS-файла (образа состояния БК),
  приводившая к невозможности загрузить файл при нахождении в режиме БК-0010;

- Изменения в драйвере клавиатуры: добавлена возможность использования 
  комбинации АР2-"ПЛЮС" (Alt =);

- Модуль эмуляции EMT 36: Преобразование рускоязычных имен файлов по 
  фонетическому признаку (замена русских символов близкими по звучанию
  латинскими);

- Исправлена серьезная ошибка в модуле преобразования имен файлов из
  принятого на БК (16 символов) в стандарт IBM (8 символов + расширение);

- Модуль эмуляции EMT 36: Обнаружена и исправлена ошибка, из-за которой
  длина загружаемого файла не заносилась в ячейку с восьмеричным адресом
  350 при адресе блока параметров 320 (из-за этой ошибки не работал BKPACK
  а также некоторые другие типы архиваторов, создававших самораспаковываю-
  щиеся модули).


v1.03
=====

- Изменен формат файлов XCOLOR.CRT и XMONO.CRT;

- Добавлено возможность совместной работы эмулятора с драйвером TV.EXE;

- Исправлена ошибка связанная с переключением типа звукового устройства
  в процессе работы (F11, I).


v1.02
=====

- Исправлена ошибка в драйвере 50 Hz таймера (неверный приоритет таймерного
  прерывания);

- Ускорена процедура эмуляции команд К1801ВМ1;

- Изменения в документации;

- Драйвер клавиатуры: комбинации АР2 + Стрелка Вправо, АР2 + Сдвижка,
  АР2 + Раздвижка, АР2 + БлокРед, АР2 + ИндСу - генерировали неверный
  скан-код (ошибка приводила к неработоспособности некоторых комбинаций
  клавиш в текстовом редакторе csiedit.exe в операционной системе CSI-DOS 3.x)
  Ошибка исправлена;

- При возобновлении нормальной работы прерванной программы после выхода из 
  программного отладчика OS-11M не восстанавливались переменные драйвера
  эмуляции системного (непрерывающего) таймера (проявлялось в PLATE, SKIN
  DIVING и др. играх, использующих таймер). Ошибка исправлена.


v1.01 BugFix
============

- Исправлена серьезная ошибка в драйвере клавиатуры, связанная с приоритетом
  обработки клавиатурных прерываний. Опция 'MKDOS' удалена из списка команд 
  конфигурационного файла за ненадобностью. Теперь в эмуляторе в Вильнюсской
  ПЗУ-версии Бейсика можно приостанавливать распечатку листинга программы
  на экране с помощью комбинации Control + Ю (как и на реальной БК-0010);

- Добавлена возможность переключения типа звукового устройства на порту
  177714 из конфигурационного меню эмулятора - F11, I (AY-3-8910, Covox
  или None).


v1.00 Release
=============

- Опиция командной строки: "/S" - для измерения скорости работы
  эмулятора;

- Увеличена скорость эмуляции команд К1801ВМ1/PDP-11 (дешифрация по таблице);
  приблизительное ускорение работы - около 1%;

- Добавлена возможность отключения переадресации EMT 36 на винчестер
  IBM PC (для устранения потенциальных конфликтов с программами), см.
  описание команды EMT36=ENA/DIS;

- Устранены многочисленные ошибки в работе программного отладчика OS-11M;

- Добавлена "горячая клавиша" Control + F12, работающая как бинарный
  переключатель режима "максимального ускорения" (см. документацию);
  полезно для ускорения time-consuming операций, например компиляции
  исходного текста.


v1.00 Beta3
===========

- Добавлена возможность вызова внешнего программного отладчика OS-11M.TR 
  by AO Corp. (комбинация Control + F10). Отладчик представляет собой 
  программу написанную в кодах БК и замещает ПЗУ Базовой Операционной 
  Системы (БОС) по адресу 140000;

- Во внутренний отладчик (вызываемый по комнбинации Control + F11)
  добавлена команда 'U' - просмотр содержимого памяти в виде ассемблерных
  мнемоник процессора PDP-11.

- Файл DOS-B11.IMG: Записана более новая версия файловой оболочки Dos-Shell;

- Изменения в коде внутреннего отладчика (Control + F11).


v1.00 Beta2
===========

- Исправлена ошибка в драйвере джойстика, приводившая к неработоспособности
  клавиши keypad-джойстика "вниз";

- В качестве кнопки "fire#1" keypad-джойстика теперь можно использовать
  только правый Control. Нажатие на левую клавишу Control используется для 
  внутренних нужд эмулятора и в драйвер джойстика не передается (однако
  правый Control все же может быть использован для вызова внутренних
  функций, например RightControl + F6 = переключение видеорежима, однако
  для этих целей не рекомендуется пользоватся правой клавишей Control, т.к.
  в порту ввода-вывода (177714 по чтению) одновременно с ее нажатием будет 
  установлен соответствующий бит, что может отразится на поведении текущей
  программы);

- Попытка загрузки BMS-файла с образом памяти БК-0011М при нахождении 
  эмулятора в режиме БК-0010 теперь блокируется с выдачей соответствующего
  диагностического сообщения;

- Внесены серьезные изменения в драйвер мыши для улучшения работы с 
  некоторыми программами;

- Исправлена ошибка в процедуре ввода с клавиатуры десятичного числа, из-за
  которой иногда невозможно было установить нулевую задержку в конфигурацион-
  ном меню эмулятора (F11);

- Добавлена возможность включения/выключения эмуляции "мыши" on the fly,
  т.е. во время работы эмулятора, через конфигурационное меню - F11,M -
  для исключения возможных конфликтов с keypad-джойстиком.

- Исправлены несколько ошибок в реализации hot-key Control-F4 и Control-F5,
  соответственно уменьшающей и увеличивающей скорость работы эмулятора;

- Исправлена ошибка в модуле поиска файла на винчестере IBM PC, из-за которой
  команда драйвера магнитофона FIND (байт-команда = 4) иногда приводила к 
  повисанию эмулятора.

- Проведен Spell-check файлов документации :-)


v1.00 Beta, compiled for Alex Shmelev
======================================

- Добавлена поддержка "мыши" БК (подключенной по общепринятой, или "прямой"
  схеме, т.е. НЕ через блок КМ);

- Добавлена команда конфигурационного файла - MOUSE=ENABLE/DISABLE;

- Незначительные изменения в коде.


v0.99c
======

- Дальнейшие исправления были внесены в код эмулятора для поддержки режима
  БК-0010;

- Добавлена проверка на пересечение с ПЗУ в модуль загрузки BIN-файлов;

- Новая управляющая клавиша - F11 - вызывает появление конфигурационного
  меню эмулятора, где можно изменить некоторые параметры, ранее доступные
  для коррекции только при редактировании файла BK11_EML.CFG. Вызвов
  встроенного отладчика перенесен на комбинацию Control-F11.


v0.99b, compiled for E.P.B.
===========================

- Добавлена возможность изменения типа эмулируемого компьютера (команда
  конфигурационного файла MODE=BK10/BK11). Пользоваться режимом BK10
  рекомендуется с осторожностью, т.к. не все процедуры были переписаны
  для поддержки режима БК-0010 (will be fixed in future versions);

- Добавлена возможность перехвата обращений к музыкальному процессору
  (команда конфигурационного файла INTERCEPT=AY).

- Новые файлы, входящие теперь в комплект эмулятора: 
  PLAYPSG.EXE - утилита для playback-а файлов в формате .PSG (Требуется
  Adlib или Sound Blaster);
  MONIT10.ROM - Монитор БК-0010;
  BASIC10.ROM - Бейсик-Вильнюс БК-0010.


v0.99a
======

- Исправлено несколько несовместимосетй с Tseng VGA BIOS;

- В эмуляторе на выходе драйвера клавиатуры вместо русской буквы 'З' 
  вырабатывался код буквы 'П'. Ошибка исправлена;

- Внесено несколько изменений в модуль определения наличия звуковой карты;

- Клавиши Control-Break и Control-C заблокированы. Из эмулятора теперь
  можно выйти только корректными методами.


v0.99
=====

- Исправлена ошибка, приводившая к неработосособности игры "PLATE" by RDA corp;

- Исправлена ошибка в драйвере дисковода, из-за которой не работал загрузчик
  демострационной программы Shock by Caroline Software;

- Значительно ускорена процедура эмуляция команд процессора;

- Добавлена еще одна "горячая клавиша" (Control + F9) - для переключения
  информационного байта по адресу 177716. Сразу после запуска эмулятора там 
  записано восьмеричное число 300 (140000 в виде слова, как и на реальной 
  БК-0011М). Однако существуют программы, которые были написаны для БК-0010 
  (например сериал Десантик В. Савина), которые ожидают что по этому адресу 
  находится число 100000 (восьмеричное), и в расчете на это осуществляют опрос
  клавиаутры. В результате в эмуляторе (а также и на реальной БК-0011М)
  с такими программами возникают проблемы с клавиатурой. Данная горячая
  клавиша работает как двоичный переключатель, позволяющий попеременно
  заносить числа 100000 и 140000 по адресу 177716 (регистр чтения);

- Добавлена команда конфигурационного файла MKDOS=ENABLE/DISABLE. Для
  нормальной работы данная опция должна быть отключена (DISABLE). При
  включении (ENABLE) позволяет частично решить клавиатурные проблемы с 
  MK-DOS v3.15. Значение по умолчанию - DISABLE.



v0.95 (30 May 1996, birthday release)
=====================================

- Исправлена ошибка в модуле анализа обращений к внешним устройствам:
  байтовая запись по адресу 177663 работала некорректно. Теперь как
  и на реальной БК-0011М запись по этому адресу вызывает модификацию
  старшего байта регистра 177662 (таймер / экран / палитры);

- По многочисленным просьбам реализована эмуляция переключения цветовых 
  палитр (регистр 177662, биты 11-8). Эмуляция может быть отключена с
  помощью команды в конфигурационном файле "PALETTE=DISABLE";

- Обнаружена и исправлена еще одна ошибка связанная с обращением к виртуальному
  диску с указанием несуществующего трека (>42 или >82);

- Изменена функция LED-индикатора "CAPS LOCK" на клавиатуре. Теперь этот
  индикатора ПОГАШЕН если клавиатура БК работает в верхнем регистре (заглавные
  буквы, default) и соответственно индикатор ЗАГОРАЕТСЯ если был осуществлен
  постоянный переход на нижний регистр (маленькие буквы) с помощью клавиши
  CAPS LOCK. В основном данное изменение было введено для совместимости
  с MS Windows'95;

- Добавлена поддержка обмена файлами с винчестером IBM PC (запись/чтение
  файлов в формате .BIN, см. документацию);

- Начиная с этой версии эмулятора корректно работают функции записи и чтения 
  файлов .BMS (Control + F2 / Control + F3). BMS файлы от эмулятора БК-0010
  (BMS_L0) также могут быть загружены;

- Исправлена ошибка в драйвере клавиатуры - при обращении к виртуальному
  диску терялись пришедшие коды нажатых клавиш. Проявлялось во вьюерах
  текстовых файлов, которые "подчитывали" информацию с диска во время
  работы (операционные системы ANDOS и RT-11).


v0.9 (26 May 1996)
==================

- Наконец-то исправлен и дополнен файл документации (BK11_EML.TXT), который
  не изменялся с версии 0.5 :-) Теперь в нем отражены все особенности
  данной версии эмулятора (0.9);

- Добавлены две новые hot-key (горячие клавиши): Control+F7 (инициализация
  муз. сопроцессора, очень полезно для некотрых программ, "оставляющих"
  играть ноты после выхода), и Control+F8 (переход по адресу 140000
  без очистки памяти БК. Совершенно необходимая клавиша если Вы занимаетесь 
  отладкой программы :-);

- Внесены коррективы в модуль эмуляции музыкального сопроцессора. Улучшена
  работа программ использующих генератор огибающих (Tower by Magic Bytes);

- Выявлена и исправлена ошибка в процедуре обновления образов гибких дисков
  БК-0011 (файлы с расширением .IMG) перед выходом из эмулятора;

- Исправлена ошибка с переключением страниц видеопамяти в альтернативном
  цветном видеорежиме во время изменения регистра рулонного сдвига (проявлялось
  в InterCommander v1.0 в операционной системе RT-11 v4.1, а также возможно
  и в других программах);

- Исправлено несколько ошибок связанных с альтернативным цветным режимом;

- Изменения в модуле инициализации Sound Blaster. Теперь эмуляция музыкального
  сопроцессора в эмуляторе не мешает background-процессу использующему
  Sound Blaster DSP (например в Win'95 можно одновременно проигрывать
  WAV-файл и работать в эмуляторе БК-11 с муз. программой использующей AY);

- Исправлена ошибка в драйвере виртуального диска при обращении к несуществую-
  щим трекам (>42 или >82). Теперь при таком обращении в эмулируемую программу
  возвращается признак ошибки в байте с абсолютным адресом 52o.


v0.8 (19 May 1996)
==================

- Внесены изменения в модуль анализа адресации команд процессора PDP-11;

- Изменена "горячая" клавиша переключения видеорежимов (цветной-монохромный):
  теперь для этой цели используется последовательность Control-F6;


v0.7 (15 May 1996)
==================

- Исправлена ошибка в драйвере виртуального диска при обращении к трекам
  40,41,42 / 80,81,82 (KEEP);

- Переписан алгоритм пересчета звуковой частоты музыкального сопроцессора
  AY-3-8910 -> Adlib. Таблица соответствия частот нотам и октавам by RDC 
  Software более не используется; вместо этого происходит realtime пересчет
  (thanks to Marat Fayzullin for formula & sources).


v0.6 (12 May 1996)
==================

- Добавлена возможность изменения карты эмулируемых дисководов (drive map);

- Ускорены подпрограммы анализа адресации команд процессора PDP-11 --
  некоторые обращения к ячейкам памяти (стеку) заменены на быстрые
  обращения к 32-разрядным регистрам процессоре i386+;

- Изменен драйвер клавиатуры. MK-DOS 3.15 теперь работает (незначительные
  проблемы с клавиатурой сохранились, однако. Я нуждаюсь в ясной
  документации по механизму обработки возникающих прерываний в БК-0011М);

- Внесены изменения в драйвер дисковода (в предыдущих версиях имелась
  незначительная ошибка при работе загрузчика операционной системы
  ANDOS v3.10;

- Серьезные изменения внесены в утилиту для создания образов дисков БК,
  называвшуюся ранее MAKE_IMG.COM (новое название -MAKE-.COM). Теперь
  она работает быстрее и надежнее. Кроме того, появилась возможность
  задания типа диска - 40 или 80 дорожек.


v0.5
====

- Первая публично распостраненная версия эмулятора.
